/***
 * GOSAScript.h
 *
 *  A scrit.  We manage loading, compiling, and executing.
 *
 *  Gordon Watts (gwatts@fnal.fnal.gov)  1995 As Is!
 ***/

#pragma once

#include "GOSAID.h"

class GOSAScript : public GOSAID {
public:
					GOSAScript (const GOSAScriptComponent *theComponent);
					GOSAScript (void);
					GOSAScript (const GOSAScriptComponent *theComponent, const OSAID theID);
					GOSAScript (const OSAID theID);
					GOSAScript (const GOSAScriptComponent *theComponent, const FSSpec &theFile);
					GOSAScript (const FSSpec &theFile);

	virtual			~GOSAScript (void);

	void			LoadFromResource (const StringPtr resourceName, const OSType resType = 'scpt');

	virtual void	Execute (AEDesc &theResult);
	virtual void	Execute (GOSAID &theResult);
	virtual void	Execute (void);
	virtual void	DoEvent (const AppleEvent &theEvent, AppleEvent &theReply) const;

protected:
	void			LoadScript (const FSSpec &theFile);
	void			LoadScript (const AEDesc &theScript);
	void			LoadFromHandle (const Handle theHandle);

	GOSAID			*mScriptContext;

};